--Settings--
local Tunnel = module("vrp", "lib/Tunnel")
local Proxy = module("vrp", "lib/Proxy")

vRP = Proxy.getInterface("vRP")
vRPclient = Tunnel.getInterface("vRP","vrp_treasureEvent")

local treasureOn = false
local treasureReward = math.random(100000,5000000)
local treasureGiftpoints = math.random(1,5)

bID = {}

local treasurePos = {
	{-1843.0511474609,-1222.5771484375,13.017202377319},
	{1959.3349609375,3853.7736816406,31.922582626343},
	{748.19641113281,1309.8937988281,360.05987548828},
	{59.570220947266,7227.4799804688,3.2259554862976},
	{1288.7685546875,-3338.755859375,5.9015126228333},
	{1919.7763671875,587.52294921875,176.30073547363},
	{184.92796325684,-776.34692382812,47.468330383301},
	{-281.92202758789,2847.1806640625,53.884952545166},
	{-1015.4860229492,-1010.6669311523,2.1503517627716},
	{-3264.4675292969,954.83160400391,8.3471612930298}
}

RegisterNetEvent('autoStopTreasureHunt')
AddEventHandler('autoStopTreasureHunt', function()
	treasureOn = false
	TriggerClientEvent('chatMessage', -1, "^8[EVENIMENT COMOARĂ] ^1Vânătoarea s-a încheiat, nimeni nu a găsit comoara!")
	local users = vRP.getUsers({})
	for k, v in pairs(users) do
		local thePlayer = v
		local plyerIndex = k
		for i, _ in pairs(treasurePos) do
			local blipID = "vRP:treasureBlip:"..i..":"..plyerIndex
			vRPclient.removeNamedBlip(thePlayer,{blipID})
		end
		local areaID = "vRP:treasureLoc:"..plyerIndex
		vRPclient.removeNamedMarker(thePlayer,{"vRP:treasureMarker:"..plyerIndex})
		vRP.removeArea({thePlayer, areaID})
	end
	TriggerClientEvent("treasureEvent:removeTreasureProp", -1)
end)

function startTreasureHunt()
	if not treasureOn then
		treasureOn = true
        treasureReward = math.random(100000,5000000)
        treasureGiftpoints = math.random(1,5)
		TriggerClientEvent('chatMessage', -1, "^8[EVENIMENT COMOARĂ] ^2A început vânătoarea de comori! Du-te la punctele marcate cu o coroană roșie pentru a găsi comoara!")
		TriggerClientEvent('chatMessage', -1, "^8[EVENIMENT COMOARĂ] ^2Ai la dispoziție ^230 de minute ^2pentru a o găsi!")

		local function treasure_enter(source, area)
			local user_id = vRP.getUserId({source})
			local users = vRP.getUsers({})
			for k, v in pairs(users) do
				local thePlayer = v
				local plyerIndex = k
				for i, _ in pairs(treasurePos) do
					local blipID = "vRP:treasureBlip:"..i..":"..plyerIndex
					vRPclient.removeNamedBlip(thePlayer,{blipID})
				end
				local areaID = "vRP:treasureLoc:"..plyerIndex
				vRPclient.removeNamedMarker(thePlayer,{"vRP:treasureMarker:"..plyerIndex})
				vRP.removeArea({thePlayer, areaID})
			end

			vRPclient.notify(source, {"~r~[EVENIMENT COMOARĂ] ~g~Ai primit ~r~$"..treasureReward.." ~g~și ~r~"..treasureGiftpoints.." Giftpoints!"})
			vRP.giveMoney({user_id, treasureReward})
			vRP.giveGiftpoints({user_id, treasureGiftpoints})
			TriggerClientEvent('chatMessage', -1, "^8[EVENIMENT COMOARĂ] ^2"..GetPlayerName(source).." a găsit comoara și a primit ^5$"..treasureReward.." ^2și ^6"..treasureGiftpoints.." Giftpoints!")
			treasureOn = false
			TriggerClientEvent("treasureEvent:removeTreasureProp", -1)
		end

		local function treasure_leave(source, area)
			return true
		end

		local users = vRP.getUsers({})
		for k, v in pairs(users) do
			local thePlayer = v
			local plyerIndex = k
			for i, loc in pairs(treasurePos) do
				local x, y, z = table.unpack(loc)
				local blipID = "vRP:treasureBlip:"..i..":"..plyerIndex
				vRPclient.setNamedBlip(thePlayer,{blipID, x, y, z, 439, 49, "Comoară"})
			end
		end

		local randLoc = math.random(#treasurePos)
		local x, y, z = table.unpack(treasurePos[randLoc])

		for i, v in pairs(users) do
			vRP.setArea({v,"vRP:treasureLoc:"..i,x,y,z,1,1.5,treasure_enter,treasure_leave})
			vRPclient.setNamedMarker(v,{"vRP:treasureMarker:"..i,x,y,z,0.7,0.7,0.5,255,245,0,125,150})
		end

		TriggerClientEvent("treasureEvent:spawnTreasureProp", -1, x, y, z)

		SetTimeout(1800000, function()
			if treasureOn then
				TriggerEvent('autoStopTreasureHunt')
			end
		end)
	end
end

RegisterCommand("trhunt", function(source, args, rawCommand)
	local user_id = vRP.getUserId({source})
	if user_id ~= nil and (user_id == 1 or user_id == 2) then
		if not treasureOn then
			startTreasureHunt()
		else
			vRPclient.notify(source, {"~r~[EVENIMENT] ~r~O vânătoare de comori este deja activă!"})
		end
	end
end)

Citizen.CreateThread(function()
	while true do
		Wait(3600000) -- o dată pe oră
		startTreasureHunt()
	end
end)
